#!/usr/bin/env bash
YW = ` echo "\033[33m" `
RD = ` echo "\033[01;31m" `
BL = ` echo "\033[36m" `
GN = ` echo "\033[1;92m" `
CL = ` echo "\033[m" `
RETRY_NUM = 10
RETRY_EVERY = 3
NUM = $RETRY_NUM
CM = " ${ GN } ✓ ${ CL } "
CROSS = " ${ RD } ✗ ${ CL } "
BFR = "\\r\\033[K"
HOLD = "-"
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die = 'EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit( ) {
trap - ERR
local reason = "Unknown failure occurred."
local msg = " ${ 1 :- $reason } "
local flag = " ${ RD } ‼ ERROR ${ CL } $EXIT @ $LINE "
echo -e " $flag $msg " 1>& 2
exit $EXIT
}
function msg_info( ) {
local msg = " $1 "
echo -ne " ${ HOLD } ${ YW } ${ msg } ... "
}
function msg_ok( ) {
local msg = " $1 "
echo -e " ${ BFR } ${ CM } ${ GN } ${ msg } ${ CL } "
}
function msg_error( ) {
local msg = " $1 "
echo -e " ${ BFR } ${ CROSS } ${ RD } ${ msg } ${ CL } "
}
msg_info "Setting up Container OS "
sed -i " / $LANG / s/\(^# \)// " /etc/locale.gen
locale-gen >/dev/null
while [ " $( hostname -I) " = "" ] ; do
1>& 2 echo -en " ${ CROSS } ${ RD } No Network! "
sleep $RETRY_EVERY
( ( NUM--) )
if [ $NUM -eq 0 ]
then
1>& 2 echo -e " ${ CROSS } ${ RD } No Network After $RETRY_NUM Tries ${ CL } "
exit 1
fi
done
msg_ok "Set up Container OS"
msg_ok " Network Connected: ${ BL } $( hostname -I) "
if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected" ; else msg_error "Internet NOT Connected" ; exit 1; fi ;
RESOLVEDIP = $( nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
if [ [ -z " $RESOLVEDIP " ] ] ; then msg_error "DNS Lookup Failure" ; else msg_ok " DNS Resolved github.com to $RESOLVEDIP " ; fi ;
msg_info "Updating Container OS"
apt-get update & >/dev/null
apt-get -y upgrade & >/dev/null
msg_ok "Updated Container OS"
msg_info "Installing Dependencies"
apt-get install -y curl & >/dev/null
apt-get install -y sudo & >/dev/null
apt-get install -y git & >/dev/null
msg_ok "Installed Dependencies"
msg_info "Setting up Node.js Repository"
curl -fsSL https://deb.nodesource.com/setup_16.x | bash - & >/dev/null
msg_ok "Set up Node.js Repository"
msg_info "Installing Node.js"
apt-get install -y nodejs & >/dev/null
msg_ok "Installed Node.js"
msg_info "Setting up MagicMirror Repository"
git clone https://github.com/MichMich/MagicMirror /opt/magicmirror & >/dev/null
msg_ok "Set up MagicMirror Repository"
msg_info "Installing MagicMirror"
cd /opt/magicmirror & >/dev/null
npm install --only= prod --omit= dev & >/dev/null
cat <<EOF > /opt/magicmirror/config/config.js
let config = {
address: "0.0.0.0" ,
port: 8080,
basePath: "/" ,
ipWhitelist: [ ] ,
useHttps: false,
httpsPrivateKey: "" ,
httpsCertificate: "" ,
language: "en" ,
locale: "en-US" ,
logLevel: [ "INFO" , "LOG" , "WARN" , "ERROR" ] ,
timeFormat: 24,
units: "metric" ,
serverOnly: true,
modules: [
{
module: "alert" ,
} ,
{
module: "updatenotification" ,
position: "top_bar"
} ,
{
module: "clock" ,
position: "top_left"
} ,
{
module: "calendar" ,
header: "US Holidays" ,
position: "top_left" ,
config: {
calendars: [
{
symbol: "calendar-check" ,
url: "webcal://www.calendarlabs.com/ical-calendar/ics/76/US_Holidays.ics"
}
]
}
} ,
{
module: "compliments" ,
position: "lower_third"
} ,
{
module: "weather" ,
position: "top_right" ,
config: {
weatherProvider: "openweathermap" ,
type: "current" ,
location: "New York" ,
locationID: "5128581" , //ID from http://bulk.openweathermap.org/sample/city.list.json.gz; unzip the gz file and find your city
apiKey: "YOUR_OPENWEATHER_API_KEY"
}
} ,
{
module: "weather" ,
position: "top_right" ,
header: "Weather Forecast" ,
config: {
weatherProvider: "openweathermap" ,
type: "forecast" ,
location: "New York" ,
locationID: "5128581" , //ID from http://bulk.openweathermap.org/sample/city.list.json.gz; unzip the gz file and find your city
apiKey: "YOUR_OPENWEATHER_API_KEY"
}
} ,
{
module: "newsfeed" ,
position: "bottom_bar" ,
config: {
feeds: [
{
title: "New York Times" ,
url: "https://rss.nytimes.com/services/xml/rss/nyt/HomePage.xml"
}
] ,
showSourceTitle: true,
showPublishDate: true,
broadcastNewsFeeds: true,
broadcastNewsUpdates: true
}
} ,
]
} ;
/*************** DO NOT EDIT THE LINE BELOW ***************/
if ( typeof module != = "undefined" ) { module.exports = config; }
EOF
msg_ok "Installed MagicMirror"
msg_info "Creating Service"
service_path = "/etc/systemd/system/magicmirror.service"
echo " [Unit]
Description = Magic Mirror
After = network.target
StartLimitIntervalSec = 0
[ Service]
Type = simple
Restart = always
RestartSec = 1
User = root
WorkingDirectory = /opt/magicmirror/
ExecStart = /usr/bin/node serveronly
[ Install]
WantedBy = multi-user.target" > $service_path
systemctl enable --now magicmirror & >/dev/null
msg_ok "Created Service"
PASS = $( grep -w "root" /etc/shadow | cut -b6) ;
if [ [ $PASS != $ ] ] ; then
msg_info "Customizing Container"
chmod -x /etc/update-motd.d/*
touch ~/.hushlogin
GETTY_OVERRIDE = "/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $( dirname $GETTY_OVERRIDE )
cat << EOF > $GE TTY_OVERRIDE
[ Service]
ExecStart =
ExecStart = -/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$ TERM
EOF
systemctl daemon-reload
systemctl restart $( basename $( dirname $GETTY_OVERRIDE ) | sed 's/\.d//' )
msg_ok "Customized Container"
fi
msg_info "Cleaning up"
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
msg_ok "Cleaned"